#ifdef WIN32
#ifdef VSTUDIO
    typedef char                int8_t;
    typedef short               int16_t;
    typedef long                int32_t;
    typedef __int64             int64_t;
    typedef unsigned char       u_int8_t;
    typedef unsigned short      u_int16_t;
    typedef unsigned long       u_int32_t;
    typedef unsigned __int64    u_int64_t;
#else
#ifndef _STDINT_H   // Ming stdint.h defines the int bitdepth types 
    typedef char                int8_t;
    typedef short               int16_t;
    typedef long                int32_t;
    typedef long long           int64_t;
#endif
    typedef unsigned char       u_int8_t;
    typedef unsigned short      u_int16_t;
    typedef unsigned long       u_int32_t;
    typedef unsigned long long  u_int64_t;
#endif
#endif

#ifdef WIN32
#define strtoll(str, end, base) _strtoi64(str, end, base)
#define strtoull(str, end, base) _strtoui64(str, end, base)
#endif

#ifdef WIN32
# define LLD "%I64d"
# define LLU "%I64u"
# define LLX "%I64x"
# define NLLD(n) "%" #n "I64d"
# define NLLU(n) "%" #n "I64u"
#else
# if __WORDSIZE == 64
#  define LLD "%ld"
#  define LLU "%lu"
#  define LLX "%lx"
#  define NLLD(n) "%" #n "ld"
#  define NLLU(n) "%" #n "lu"
# else
#  define LLD "%lld"
#  define LLU "%llu"
#  define LLX "%llx"
#  define NLLD(n) "%" #n "lld"
#  define NLLU(n) "%" #n "llu"
# endif
#endif
